import './index.css';
import nameGenerator from './name-generator';
import isDef from './is-def';



// Store/retrieve the name in/from a cookie.
const cookies = document.cookie.split(';');
console.log(cookies)
let wsname = cookies.find(function(c) {
  if (c.match(/wsname/) !== null) return true;
  return false;
});
if (isDef(wsname)) {
  wsname = wsname.split('=')[1];
} else {
  wsname = nameGenerator();
  document.cookie = "wsname=" + encodeURIComponent(wsname);
}

// Variables :
var color = "#000";
var width_brush = 5;

var dessinsDispo = [];

// Set the name in the header
document.querySelector('header>p').textContent = decodeURIComponent(wsname);

// Create a WebSocket connection to the server
const ws = new WebSocket("ws://" + window.location.host+ "/socket");

document.addEventListener("DOMContentLoaded", function() {

  var mouse = {
    click: false,
    move: false,
    pos: {x:0, y:0},
    pos_prec: false
  };

  var canvas = document.getElementById('canvas');
  var context = canvas.getContext('2d');

  var listCouleurs = document.getElementById('couleurs');
  var resetCanvas = document.getElementById('resetCanvas');

  var tailleCrayon = document.getElementById('largeurs_pinceau');

  var saveImage = document.getElementById('saveImage');

  var width = context.canvas.clientWidth;
  var height = context.canvas.clientHeight;

  var rect = canvas.getBoundingClientRect();

  // Trait arrondi :
  context.lineJoin = 'round';
  context.lineCap = 'round';

  //document.body.onmousedown = function(e) { mouse.click = false; };
  canvas.onmouseout = function(e) {
    if(mouse.click === true) { mouse.click = false; }
  };

  // Lorsque on appuie
  canvas.onmousedown = function(e) { mouse.click = true; };

  // Lorsque lache le click de la souris
  canvas.onmouseup = function(e) { mouse.click = false; };

  // Lorsqu'on deplace la souris sur le canvas
  canvas.onmousemove = function(e) {

    //e.clientX = parseInt((e.pageX - rect.left) - 10); // 10 = dÃ©calage du curseur
    //e.clientY = parseInt((e.pageY - rect.top) - 10);

    mouse.pos.x = parseFloat((e.clientX - canvas.offsetLeft) - 10) / width;
    mouse.pos.y = parseFloat((e.clientY - canvas.offsetTop) - 10) / height;//e.clientY / height;

    mouse.move = true;
  };



  listCouleurs.onclick = function(e) {

    var couleur = e.target.getAttribute('data-couleur');

    if(couleur !== null) {
      color = couleur;
    }
    //console.log(e.target.getAttribute('data-couleur'));
  }

  resetCanvas.onclick = function(e) {

    ws.send("clear");
  }

  tailleCrayon.onchange = function(e) {

    if(e.target.value !== null) {
      width_brush = e.target.value;
      document.getElementById('output').innerHTML = width_brush + " pixels";
    }
  }

  function loadImage(e) {

    var base_image = e;
    context.drawImage(base_image, width, height);
  }

  saveImage.onclick = function(e) {

    if(dessinsDispo.length <= 3) {

        var i = 0;

        if(dessinsDispo.length !== 0) {
          i = dessinsDispo.length-1;
        }

        var canvas_tmp = document.getElementById("canvas");	// Ca merde en pernant le selecteur jQuery
        var listDessins = document.getElementById("listDessinsContent");
        var image = document.createElement("img");
        image.setAttribute("id", "dessins"+i);
        image.setAttribute("src", canvas_tmp.toDataURL("image/png"));
        image.setAttribute("onclick", "loadImage(this.src)");
        var line = document.createElement("li");
        line.appendChild(image);
        listDessins.appendChild(line);

        dessinsDispo.push({imageURL: canvas_tmp.toDataURL("image/png"), imageName: "monDessinNumber" + i });

      }
      else {
        alert("Le nombre de dessins maximum a été atteint");
      }

		//window.location = canvas_tmp.toDataURL("image/png");
  }



  /*$(this).click(function() {
    // Je change la couleur du pinceau :
    color = $(this).attr("data-couleur");

    // Et les classes CSS :
    $("#couleurs a").removeAttr("class", "");
    $(this).attr("class", "actif");

    return false;
  });*/

  // We get notified once connected to the server
  ws.onopen = (event) => {
    console.log("Vous êtes connecté !");
  };

  // Listen to messages coming from the server. When it happens, create a new <li> and append it to the DOM.
  //const messages = document.querySelector('#messages');
  //let line;
  ws.onmessage = (event) => {
    /*var reponse = event.data.split(';');

    //console.log(painting);

    //console.log(reponse);
    console.log(reponse[0]);
    userList[reponse[0]] = { x: reponse[1], y: reponse[2] };
    */

    var test = event.data.split(";");

    if(test.length > 1) {

      if(test[0] === "stockMemory") {
        var recuperation = JSON.parse(test[2]);
        var couleur = recuperation.couleur;

        var taille = recuperation.taille;

        recuperation = recuperation.line;

        context.beginPath();
        context.lineWidth = taille;
        context.strokeStyle = couleur;
        context.moveTo(recuperation[0].x * width, recuperation[0].y * height);
        context.lineTo(recuperation[1].x * width, recuperation[1].y * height);
        context.stroke();
      }
      else 
      {
        if(test[2] === "clear") {
            context.clearRect(0,0, width, height);
        }
        else {

          var line = JSON.parse(test[2]);

          var taille = line.taille;
          var couleur = line.couleur;
          line = line.line;

          //console.log(test[0]);

          //if(test[0] !== "[Brave Semicircle] ") {

            // DESSINE PAS
          //}
          //else {
            context.beginPath();
            context.lineWidth = 2;
            context.strokeStyle = couleur;
      			context.lineWidth = taille;
            context.moveTo(line[0].x * width, line[0].y * height);
            context.lineTo(line[1].x * width, line[1].y * height);
            context.stroke();
          }
        //}*/
      }
    }

  };

  function loopReader() {

    if(mouse.click && mouse.move && mouse.pos_prev) {

      var obj = { line: [ mouse.pos, mouse.pos_prev ], couleur: color, taille: width_brush };

      ws.send(JSON.stringify(obj));
      ws.binaryType = "arraybuffer";
      mouse.move = false;

    }

    mouse.pos_prev = {x: mouse.pos.x, y: mouse.pos.y};
    setTimeout(loopReader, 25);
  }

  loopReader();

});


//  if()

//  if(painting) {
  //drawLine();
//  }

  /*if(decodeURIComponent(wsname) === "Cute Whorl") {

      //console.log(decodeURIComponent(wsname));

      //cursorX = (cursorX - rect.left) - 10; // 10 = dÃ©calage du curseur
      //cursorY = (cursorY - rect.top) - 10;

  }
  else {

    if(painting) {

      //console.log(decodeURIComponent(wsname));

      //cursorX = (cursorX - rect.left) - 10; // 10 = dÃ©calage du curseur
      //cursorY = (cursorY - rect.top) - 10;

      if (!started) {
    		// Je place mon curseur pour la premiÃ¨re fois :
    		context.beginPath();
    		context.moveTo(cursorX, cursorY);
    		started = true;
    	}
    	// Sinon je dessine
    	else {
    		context.lineTo(cursorX, cursorY);
    		context.strokeStyle = color;
    		context.lineWidth = width_brush;
    		context.stroke();
    	}
    }
  */

  //  alert("TES MOCHE BAPTISTE");
  //}
  /*painting = false;
	started = false;
*/
//  drawLine();

  //if(reponse[3] && reponse[2]) {

  /*  painting = (reponse[3] === "false");
    cursorX = reponse[0];
    cursorY = reponse[1];
    started = (reponse[2] === "false" || reponse[2] === "true");
*/
  //drawLine();

// Retrieve the input element. Add listeners in order to send the content of the input when the "return" key is pressed.
/*function sendMessage(event) {
  event.preventDefault();
  event.stopPropagation();
  if (sendInput.value !== '') {
    // Send data through the WebSocket
    ws.send(sendInput.value);
    sendInput.value = '';
  }
}*/
/*
const sendForm = document.querySelector('form');
const sendInput = document.querySelector('form input');
sendForm.addEventListener('submit', sendMessage, true);
sendForm.addEventListener('blur', sendMessage, true);
*/
